Z-order in the EJ2 JavaScript Image Editor control

25 Mar 20256 minutes to read

We are excited to introduce z-order support in the Image Editor. It’s a powerful tool that allows users to adjust the positioning of annotations. This feature is particularly useful for designing personalized templates like greeting cards or posters, where managing the layering of multiple annotations is crucial for a polished final product.

Types of adjustment in the Image Editor z-order support.

  • Bring forward - Switch the selected annotation with the annotation one layer ahead of it.

  • Sent Backward - Switch the selected annotation with the annotation one layer behind it.

  • Bring to Front - Move the selected annotation to ahead of all other annotations.

  • Send to Back - Move the selected annotation to behind all other annotations.

In the following example, you can use the z-order support.

ej.base.enableRipple(true);

var imageEditorObj = new ej.imageeditor.ImageEditor({
  width: '550px',
  height: '330px',
  created: function () {
    if (ej.base.Browser.isDevice) {
      imageEditorObj.open('bee-eater.png');
    } else {
      imageEditorObj.open('bee-eater.png');
    }
  }
});
imageEditorObj.appendTo('#imageeditor');

document.getElementById('drawShapes').onclick = function () {
  let dimension = imageEditorObj.getImageDimension();
  imageEditorObj.drawRectangle(dimension.x + 10, dimension.y + 10, 150, 70, null, null, 'red');
  imageEditorObj.drawRectangle(dimension.x + 20, dimension.y + 20, 150, 70, null, null, 'red');
  imageEditorObj.drawRectangle(dimension.x + 30, dimension.y + 30, 150, 70, null, null, 'green');
  imageEditorObj.drawRectangle(dimension.x + 40, dimension.y + 40, 150, 70, null, null, 'red');
};
document.getElementById('bringForward').onclick = function () {
  imageEditorObj.bringForward('shape_3');
};
document.getElementById('sendBackward').onclick = function () {
  imageEditorObj.sendBackward('shape_3');
};
document.getElementById('bringToFront').onclick = function () {
  imageEditorObj.bringToFront('shape_3');
};
document.getElementById('sendToBack').onclick = function () {
  imageEditorObj.sendToBack('shape_3');
};
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-splitbuttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-image-editor/styles/material.css" rel="stylesheet">

    <!--style reference from app-->
    <link href="styles.css" rel="stylesheet">

    <!--system js reference and configuration-->
    <script src="https://cdn.syncfusion.com/ej2/31.2.12/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div class="control-section">
            <div id="imageeditor" class="row"></div>
            <div>
                <button id="drawShapes" class="e-btn e-primary">Draw Shapes</button>
                <button id="bringForward" class="e-btn e-primary">Bring Forward</button>
                <button id="sendBackward" class="e-btn e-primary">Sent Backward</button>
                <button id="bringToFront" class="e-btn e-primary">Bring to Front</button>
                <button id="sendToBack" class="e-btn e-primary">Send to Back</button>
            </div>
        </div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Z-order in the Vue Image Editor component

28 Feb 20258 minutes to read

We are excited to introduce z-order support in the Image Editor. It’s a powerful tool that allows users to adjust the positioning of annotations. This feature is particularly useful for designing personalized templates like greeting cards or posters, where managing the layering of multiple annotations is crucial for a polished final product.

Types of adjustment in the Image Editor z-order support.

  • Bring forward - Switch the selected annotation with the annotation one layer ahead of it.

  • Sent Backward - Switch the selected annotation with the annotation one layer behind it.

  • Bring to Front - Move the selected annotation to ahead of all other annotations.

  • Send to Back - Move the selected annotation to behind all other annotations.

In the following example, you can use the z-order support.

<template>
    <div>
        <ejs-imageeditor id="image-editor" ref="imageEditorObj" height="350px" width="550px" :created="created"></ejs-imageeditor>
        <ejs-button cssClass="e-img-button" :isPrimary="true" v-on:click="drawShapes">Draw Shapes</ejs-button>
        <ejs-button cssClass="e-img-button" :isPrimary="true" v-on:click="bringForward">Bring Forward</ejs-button>
        <ejs-button cssClass="e-img-button" :isPrimary="true" v-on:click="sendBackward">Send Backward</ejs-button>
        <ejs-button cssClass="e-img-button" :isPrimary="true" v-on:click="bringToFront">Bring To Front</ejs-button>
        <ejs-button cssClass="e-img-button" :isPrimary="true" v-on:click="sendToBack">Send To Back</ejs-button>
    </div>
</template>

<script setup>

import { ImageEditorComponent as EjsImageeditor } from "@syncfusion/ej2-vue-image-editor";
import { ButtonComponent as EjsButton } from '@syncfusion/ej2-vue-buttons';
import { Browser } from "@syncfusion/ej2-base";
import { ref } from "vue";

const imageEditorObj = ref(null);

const created = () => {
    const imageEditor = imageEditorObj.value?.ej2Instances;
    if (!imageEditor) return;
    let imageUrl = Browser.isDevice
        ? "https://ej2.syncfusion.com/vue/documentation/image-editor/images/flower.jpeg"
        : "https://ej2.syncfusion.com/vue/documentation/image-editor/images/bridge.jpeg";
    imageEditor.open(imageUrl);
};

const drawShapes = () => {
    let dimension = imageEditorObj.value.ej2Instances.getImageDimension();
    imageEditorObj.value.ej2Instances.drawRectangle(dimension.x + 10, dimension.y + 10, 150, 70, null, null, 'red');
    imageEditorObj.value.ej2Instances.drawRectangle(dimension.x + 20, dimension.y + 20, 150, 70, null, null, 'red');
    imageEditorObj.value.ej2Instances.drawRectangle(dimension.x + 30, dimension.y + 30, 150, 70, null, null, 'green');
    imageEditorObj.value.ej2Instances.drawRectangle(dimension.x + 40, dimension.y + 40, 150, 70, null, null, 'red');
};

const bringForward = () => {
    imageEditorObj.value.ej2Instances.bringForward('shape_3');
};

const sendBackward = () => {
    imageEditorObj.value.ej2Instances.sendBackward('shape_3');
};

const bringToFront = () => {
    imageEditorObj.value.ej2Instances.bringToFront('shape_3');
};

const sendToBack = () => {
    imageEditorObj.value.ej2Instances.sendToBack('shape_3');
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-lists/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-dropdowns/styles/material.css";
@import "../node_modules/@syncfusion/ej2-image-editor/styles/material.css";


#image-editor {
    width: 550px !important;
    height: 350px !important;
}
</style>
<template>
  <div>
    <ejs-imageeditor id="image-editor" ref="imageEditorObj" height="350px" width="550px"
      :created="onCreated"></ejs-imageeditor>
    <ejs-button cssClass="e-img-button" :isPrimary="true" v-on:click="drawShapes">Draw Shapes</ejs-button>
    <ejs-button cssClass="e-img-button" :isPrimary="true" v-on:click="bringForward">Bring Forward</ejs-button>
    <ejs-button cssClass="e-img-button" :isPrimary="true" v-on:click="sendBackward">Send Backward</ejs-button>
    <ejs-button cssClass="e-img-button" :isPrimary="true" v-on:click="bringToFront">Bring To Front</ejs-button>
    <ejs-button cssClass="e-img-button" :isPrimary="true" v-on:click="sendToBack">Send To Back</ejs-button>
  </div>
</template>

<script>

import { ImageEditorComponent } from "@syncfusion/ej2-vue-image-editor";
import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';
import { Browser } from "@syncfusion/ej2-base";

export default {
  name: "App",
  components: {
    "ejs-imageeditor": ImageEditorComponent,
    "ejs-button": ButtonComponent
  },
  data: function () {
    return {};
  },
  methods: {
    onCreated() {
      let imageEditor = this.$refs.imageEditorObj?.ej2Instances;
      if (!imageEditor) return;
      let imageUrl = Browser.isDevice
        ? 'https://ej2.syncfusion.com/vue/documentation/image-editor/images/flower.jpeg'
        : 'https://ej2.syncfusion.com/vue/documentation/image-editor/images/bridge.jpeg';
      imageEditor.open(imageUrl);
    },
    drawShapes: function () {
      let dimension = this.$refs.imageEditorObj.ej2Instances.getImageDimension();
      this.$refs.imageEditorObj.ej2Instances.drawRectangle(dimension.x + 10, dimension.y + 10, 150, 70, null, null, 'red');
      this.$refs.imageEditorObj.ej2Instances.drawRectangle(dimension.x + 20, dimension.y + 20, 150, 70, null, null, 'red');
      this.$refs.imageEditorObj.ej2Instances.drawRectangle(dimension.x + 30, dimension.y + 30, 150, 70, null, null, 'green');
      this.$refs.imageEditorObj.ej2Instances.drawRectangle(dimension.x + 40, dimension.y + 40, 150, 70, null, null, 'red');
    },
    bringForward: function () {
      this.$refs.imageEditorObj.ej2Instances.bringForward('shape_3');
    },
    sendBackward: function () {
      this.$refs.imageEditorObj.ej2Instances.sendBackward('shape_3');
    },
    bringToFront: function () {
      this.$refs.imageEditorObj.ej2Instances.bringToFront('shape_3');
    },
    sendToBack: function () {
      this.$refs.imageEditorObj.ej2Instances.sendToBack('shape_3');
    },
  }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-lists/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-dropdowns/styles/material.css";
@import "../node_modules/@syncfusion/ej2-image-editor/styles/material.css";

#image-editor {
  width: 550px !important;
  height: 350px !important;
}
</style>

Z-order in the Angular Image Editor component

24 Feb 20254 minutes to read

We are excited to introduce z-order support in the Image Editor. It’s a powerful tool that allows users to adjust the positioning of annotations. This feature is particularly useful for designing personalized templates like greeting cards or posters, where managing the layering of multiple annotations is crucial for a polished final product.

Types of adjustment in the Image Editor z-order support.

  • Bring forward - Switch the selected annotation with the annotation one layer ahead of it.

  • Sent Backward - Switch the selected annotation with the annotation one layer behind it.

  • Bring to Front - Move the selected annotation to ahead of all other annotations.

  • Send to Back - Move the selected annotation to behind all other annotations.

In the following example, you can use the z-order support.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ImageEditorModule, ImageEditorComponent } from '@syncfusion/ej2-angular-image-editor';
import { Component, ViewChild } from '@angular/core';
import { Browser } from '@syncfusion/ej2-base';

@Component({
  imports: [ImageEditorModule],
  standalone: true,
  selector: 'app-root',
  template: `<div class="e-section-control">
              <!-- To render Image Editor. -->
              <div id="wrapperDiv" style="width:550px;height:350px;">
                <ejs-imageeditor #imageEditor (created)="created()"></ejs-imageeditor>
                <button class="e-btn e-primary" (click)="drawShapes()">Draw Shapes</button>
                <button class="e-btn e-primary" (click)="bringForward()">Bring Forward</button>
                <button class="e-btn e-primary" (click)="sendBackward()">Send Backward</button>
                <button class="e-btn e-primary" (click)="bringToFront()">Bring To Front</button>
                <button class="e-btn e-primary" (click)="sendToBack()">Send To Back</button>
              </div>
              </div>`
})

export class AppComponent {
  @ViewChild('imageEditor')
  public imageEditorObj?: ImageEditorComponent;
  public created(): void {
    if (Browser.isDevice) {
      this.imageEditorObj?.open('./flower.png');
    }
    else {
      this.imageEditorObj?.open('./bridge.png');
    }
  }
  drawShapes(): void {
    let dimension: any = this.imageEditorObj?.getImageDimension();
    this.imageEditorObj?.drawRectangle(dimension.x + 10, dimension.y + 10, 150, 70, 2, '', 'red');
    this.imageEditorObj?.drawRectangle(dimension.x + 20, dimension.y + 20, 150, 70, 2, '', 'red');
    this.imageEditorObj?.drawRectangle(dimension.x + 30, dimension.y + 30, 150, 70, 2, '', 'green');
    this.imageEditorObj?.drawRectangle(dimension.x + 40, dimension.y + 40, 150, 70, 2, '', 'red');
  }
  bringForward(): void {
    this.imageEditorObj?.bringForward('shape_3');
  }
  sendBackward(): void {
    this.imageEditorObj?.sendBackward('shape_3');
  }
  bringToFront(): void {
    this.imageEditorObj?.bringToFront('shape_3');
  }
  sendToBack(): void {
    this.imageEditorObj?.sendToBack('shape_3');
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Z-Order in Image Editor component

25 Mar 202511 minutes to read

We are excited to introduce z-order support in the Image Editor. It’s a powerful tool that allows users to adjust the positioning of annotations. This feature is particularly useful for designing personalized templates like greeting cards or posters, where managing the layering of multiple annotations is crucial for a polished final product.

Types of adjustment in the Image Editor z-order support.

  • Bring forward - Switch the selected annotation with the annotation one layer ahead of it.

  • Sent Backward - Switch the selected annotation with the annotation one layer behind it.

  • Bring to Front - Move the selected annotation to ahead of all other annotations.

  • Send to Back - Move the selected annotation to behind all other annotations.

In the following example, you can use the z-order support.

import { ImageEditorComponent } from '@syncfusion/ej2-react-image-editor';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { Browser } from '@syncfusion/ej2-base';
import * as React from 'react';
import * as ReactDOM from "react-dom";

export default class App extends React.Component {
    imgObj;
    imageEditorCreated() {
        if (Browser.isDevice) {
            this.imgObj.open('https://ej2.syncfusion.com/react/documentation/image-editor/images/flower.jpeg');
        }
        else {
            this.imgObj.open('https://ej2.syncfusion.com/react/documentation/image-editor/images/bridge.jpeg');
        }
    }
    drawShapes() {
        let dimension = this.imgObj.getImageDimension();
        this.imgObj.drawRectangle(dimension.x + 10, dimension.y + 10, 150, 70, null, null, 'red');
        this.imgObj.drawRectangle(dimension.x + 20, dimension.y + 20, 150, 70, null, null, 'red');
        this.imgObj.drawRectangle(dimension.x + 30, dimension.y + 30, 150, 70, null, null, 'green');
        this.imgObj.drawRectangle(dimension.x + 40, dimension.y + 40, 150, 70, null, null, 'red');
    }
    bringForward() {
        this.imgObj.bringForward('shape_3');
    }
    sendBackward() {
        this.imgObj.sendBackward('shape_3');
    }
    bringToFront() {
        this.imgObj.bringToFront('shape_3');
    }
    sendToBack() {
        this.imgObj.sendToBack('shape_3');
    }
    render() {
        return (<div className='e-img-editor-sample'>
            <ImageEditorComponent ref={(img) => { this.imgObj = img; }} height="350px" created={this.imageEditorCreated.bind(this)}></ImageEditorComponent>
            <div>
                <ButtonComponent cssClass='e-primary' content='Draw Shapes' onClick={this.drawShapes.bind(this)} />
                <ButtonComponent cssClass='e-primary' content='Bring Forward' onClick={this.bringForward.bind(this)} />
                <ButtonComponent cssClass='e-primary' content='Sent Backward' onClick={this.sendBackward.bind(this)} />
                <ButtonComponent cssClass='e-primary' content='Bring to Front' onClick={this.bringToFront.bind(this)} />
                <ButtonComponent cssClass='e-primary' content='Send to Back' onClick={this.sendToBack.bind(this)} />
            </div>
        </div>);
    }
}
ReactDOM.render(<App />, document.getElementById('image-editor'));
import { ImageEditorComponent } from '@syncfusion/ej2-react-image-editor';
import { ButtonComponent } from '@syncfusion/ej2-react-buttons';
import { Browser } from '@syncfusion/ej2-base';
import * as React from 'react';
import * as ReactDOM from "react-dom";

function App() {
    let imgObj: ImageEditorComponent;
    function imageEditorCreated(): void {
        if (Browser.isDevice) {
            imgObj.open('https://ej2.syncfusion.com/react/documentation/image-editor/images/flower.jpeg');
        } else {
            imgObj.open('https://ej2.syncfusion.com/react/documentation/image-editor/images/bridge.jpeg');
        }
    }
    function drawShapes(): void {
        let dimension = imgObj.getImageDimension();
        imgObj.drawRectangle(dimension.x + 10, dimension.y + 10, 150, 70, null, null, 'red');
        imgObj.drawRectangle(dimension.x + 20, dimension.y + 20, 150, 70, null, null, 'red');
        imgObj.drawRectangle(dimension.x + 30, dimension.y + 30, 150, 70, null, null, 'green');
        imgObj.drawRectangle(dimension.x + 40, dimension.y + 40, 150, 70, null, null, 'red');
    }
    function bringForward(): void {
        imgObj.bringForward('shape_3');
    }
    function sendBackward(): void {
        imgObj.sendBackward('shape_3');
    }
    function bringToFront(): void {
        imgObj.bringToFront('shape_3');
    }
    function sendToBack(): void {
        imgObj.sendToBack('shape_3');
    }

    return (
        <div className='e-img-editor-sample'>
            <ImageEditorComponent ref={(img) => { imgObj = img }} created={imageEditorCreated}></ImageEditorComponent>
            <div>
                <ButtonComponent cssClass='e-primary' content='Draw Shapes' onClick={drawShapes} />
                <ButtonComponent cssClass='e-primary' content='Bring Forward' onClick={bringForward} />
                <ButtonComponent cssClass='e-primary' content='Sent Backward' onClick={sendBackward} />
                <ButtonComponent cssClass='e-primary' content='Bring to Front' onClick={bringToFront} />
                <ButtonComponent cssClass='e-primary' content='Send to Back' onClick={sendToBack} />
            </div>
        </div>
    );
}
export default App;

ReactDOM.render(<App />, document.getElementById('image-editor'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Image Editor</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-base/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-buttons/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-splitbuttons/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-popups/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-inputs/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-navigations/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/ej2-image-editor/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/31.2.12/material.css"rel="stylesheet">
	<link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
        <div id='image-editor'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>